VERSION 0.8 # https://docs.earthly.dev/docs/earthfile#version
FROM python:3

ARG --global build_dir="dist"


################
# Main targets #
################

{% include "./fragments/node.earth" %}

build:
    ARG yama_env="production"

    FROM +node-base
    WORKDIR /workdir

    # NOTE: change this if you set a custom cacheDir in your astro config
    LET astro_cacheDir="./node_modules/.astro"
    CACHE $astro_cacheDir

    COPY . .

    # Uncomment if you wish to disable telemetry. Learn more at: https://docs.astro.build/en/reference/cli-reference/#astro-telemetry
    #ENV ASTRO_TELEMETRY_DISABLED=1
    ENV YAMA_ENV=$yama_env

    # Assumes you have a "build" script in your package.json to run `astro build`. Edit as needed.
    RUN yarn run build

    SAVE ARTIFACT $build_dir build_result AS LOCAL $build_dir



##################
# Helper targets #
##################

{% include "./fragments/node-helpers.earth" %}

# Run `astro dev` dev server with $PWD mounted. Run locally with `earthly +dev`.
# Note that if you exit Earthly (eg. via Ctrl+c), Earthly will immediately exit and leave the container running.
# You can manually stop it with `earthly +stop-dev` (or `docker stop earthly-dev-server`).
dev:
    ARG port=4321
    ARG container_name="earthly-dev-server"
    LOCALLY
        WITH DOCKER --load earthly-dev-server-image=+node-base
            RUN docker run --rm -i \
                        --volume="$PWD":/workdir:Z \
                        --publish $port:4321 \
                        --name="$container_name" \
                        earthly-dev-server-image \
                        yarn run dev --host
        END

stop-dev:
    ARG container_name="earthly-dev-server"

    LOCALLY
        RUN docker stop $container_name



################
# Swift upload #
################

{% include "./fragments/swift.earth" %}
